<?
/*
--------------------------------------------------------------------------------
     Info : Klasa umoliwiajca autoryzacj uytkownikw z wykorzystaniem
          : plikw tekstowych.
          :
--------- : --------------------------------------------------------------------
    Autor : Mariusz Kacki
   E-mail : robokator@wp.pl
     Data : 10:25 03-07-24
--------- : --------------------------------------------------------------------
   Metody : bool is_logged(void)                                - czy zalogowany
          : bool login(string $login, string $passwd)                  - zaloguj
          : array users(void)                         - tablica zarejestrowanych
          : string user(void)                            - zalogowany uytkownik
          : integer count(void)                        - liczba zarejestrowanych
          : bool is_user(string $login)                - czy uytkownik istnieje
          : bool add_user(string $login, string $passwd)     - dodaj uytkownika
          : void logout(void)                                          - wyloguj
          : string version(void)                           - informacje o klasie
--------- : --------------------------------------------------------------------
Wasnoci : VERSION                                       - informacjie o klasie
          : LOGGED                                              - czy zalogowany
          : USER                                             - nazwa uytkownika
          : FILE                                                   - nazwa pliku
--------- : --------------------------------------------------------------------
Komentarz : Nie naley si odwoywa bezporednio do wasnoci z zewntrz klasy,
          : a przez odpowiednie metody.
          : Wszystkie wasnoi maj charakter prywatny i nie naley ich modyfi-
          : kowa z zewntrz.
----------:---------------------------------------------------------------------
*/



class auth
{    
  var $VERSION = "'MK Auth 1.0', Copyrights &copy; 2003 by Mariusz Kacki";
  var $LOGGED  = False;
  var $USER    = '';
  var $FILE    = '';


  
  // Konstruktor, sprawdza istnienie pliku itp. ********************************
  function auth ($fileName = '')
  {
    $this->FILE = $fileName; 
    if (!file_exists ($this->FILE))
    {
      exit ("Bd: Plik <b>'$fileName'</b> nie istnieje.<br>");
    }
  }



  // Sprawdza czy uytkownik jest zalogowany ***********************************
  function is_logged ()
  {
    return ($this->LOGGED);
  }



  // Loguje uytkownika ********************************************************
  function login ($login = '', $passwd = '')
  {
    $line = @file ($this->FILE);
    foreach ($line as $value)
    {
      $str = explode (',', $value);
      if (chop ($str[0])==$login && chop ($str[1])==$passwd)
      {
        $this->LOGGED = True;
        $this->USER   = $login;
        return (True);
      }
    }
    return (False);
  }



  //  Zwraca tablic zarejestrowanych uzytkownikw *****************************
  function users ()
  {
    $line = @file ($this->FILE);
    $usr = array ();
    foreach ($line as $value)
    {
      $str = explode (',', $value);
      $usr[] = chop ($str[0]);
    }
    return ($usr);
  }
  


  // nazwa zalogowanego uytkownika ********************************************
  function user ()
  {
    return ($this->USER);
  }



  // ilo zarejestrowanych uytkownikw ***************************************
  function count ()
  {
    return (count (@file ($this->FILE)));
  }



  // Sprawdza czy uytkownik istnieje ******************************************
  function is_user ($login = '')
  {
    $line = @file ($this->FILE);
    foreach ($line as $value)
    {
      $str = explode (',', $value);
      if (chop ($str[0])==$login)
      {
        return (True);
      }
    }
    return (False);
  }
  
  
  
  // Dodaje nowego uytkownika *************************************************
  function add_user ($login = '', $passwd = '')
  {
    if ($fp = @fopen ($this->FILE, 'a'))
    {
      flock ($fp, 2);
      fputs ($fp, "$login,$passwd\n");
      flock ($fp, 3);
      fclose ($fp);
      return (True);
    }
    return (False);
  }



  // Wylogowanie uytkownika ***************************************************
  function logout ()
  {
    $this->USER   = '';
    $this->LOGGED = False;
    return;
  }



  // Wersja skryptu ************************************************************
  function version ()
  {
    return ($this->VERSION);
  }


}

?>
